#!/usr/bin/env python

import sys
import pygame
from pygame.locals import *
from math import *
ac1 = 1.4
ac2 = 0.09


def ffnc(rercs, cc, a1,a2):
	pos = cc[0]
	x = pos[0]
	y = pos[1]
	intpos = (int(x),int(y))
	rad = cc[1]
	fcol = ((rercs*20)%255,255-(a1[0]*a1[1]*200)%255,(x+128)%255)
	
	
	pygame.draw.circle(screen, (0,0,0)	,intpos,int(rad)+1)
	pygame.draw.circle(screen, fcol		,intpos,int(rad))
	if rercs > 0:
		
		tpl = (x+a1[0]*rad,	y+a1[1]*rad)
		tpr = (x+a2[0]*rad,	y+a2[1]*rad)
		for i in range(100):
			lrv = (tpl[0]-tpr[0],tpl[1]-tpr[1])
			srad = hypot(lrv[0],lrv[1])
			tpl = (x+a1[0]*(rad-(srad/2)),	y+a1[1]*(rad-(srad/2)))
			tpr = (x+a2[0]*(rad-(srad/2)),	y+a2[1]*(rad-(srad/2)))
		
		lrv = (lrv[0]/srad,lrv[1]/srad)
		rlv = (-lrv[0],-lrv[1])
		srad*=0.5
		tpl = (x+a1[0]*(rad-srad),	y+a1[1]*(rad-srad))
		tpr = (x+a2[0]*(rad-srad),	y+a2[1]*(rad-srad))
		
		lrv = (tpl[0]-tpr[0],tpl[1]-tpr[1])
		lrmag = hypot(lrv[0],lrv[1])
		lrv = (lrv[0]/lrmag,lrv[1]/lrmag)
		rlv = (-lrv[0],-lrv[1])
		
		
		brad = (rad-srad)
		tpm = ((tpl[0]+tpr[0])/2,(tpl[1]+tpr[1])/2)
		middlevec = (tpm[0]-x,tpm[1]-y)
		tempml = hypot(middlevec[0],middlevec[1])
		middlevec = (-middlevec[0]/tempml,-middlevec[1]/tempml)
		tpm = (x+middlevec[0]*(rad-brad),y+middlevec[1]*(rad-brad))
		
		blv = (tpl[0]-tpm[0],tpl[1]-tpm[1])
		blmag = hypot(blv[0],blv[1])
		blv = (blv[0]/blmag,blv[1]/blmag)
		lbv = (-blv[0],-blv[1])
		
		brv = (tpr[0]-tpm[0],tpr[1]-tpm[1])
		brmag = hypot(brv[0],brv[1])
		brv = (brv[0]/brmag,brv[1]/brmag)
		rbv = (-brv[0],-brv[1])
		
		#if rercs == 1 or rercs == 2:
		pygame.draw.aalines(screen, (255,0,0),0, [tpl,tpr],1)
		pygame.draw.aalines(screen, (0,255,0),0, [tpm,tpr],1)
		pygame.draw.aalines(screen, (0,0,255),0, [tpm,tpl],1)
		
		cb  = [tpm,brad]
		csl = [tpl,srad]
		csr = [tpr,srad]
		
		ffnc(rercs-1, cb,blv,brv)
		ffnc(rercs-1, csr,rbv,lrv)
		ffnc(rercs-1, csl,lbv,rlv)
	else:
		pass
		pygame.draw.circle(screen, (0,0,0)	,intpos,int(rad)+1)
		pygame.draw.circle(screen, fcol		,intpos,int(rad))

pygame.init()
screen  = pygame.display.set_mode((1024,768),0,32)
ingame = 1
while ingame:
	pygame.time.wait(1)
	
	ac1-=0.0243
	ac2+=0.0016
	screen.fill((0,0,0))
	ffnc(5, [(1024/2,768/2),768/2],(cos(ac2),sin(ac2)),(cos(ac1),sin(ac1)))
	pygame.display.flip()












