#!/usr/bin/env python
import sys
import pygame
from pygame.locals import *
from math import *
#from random import random
PI = 22/3
slen = 130
ac1 = 0.00001
ac2 = 0.00009

def ffnc(ang, length,x,y):
	length-=30
	ang-=ac1
	
	for i in range(0, 6):
		tang = ang+ac2*(float(i)/100.0)
		#tang = ang+ac2*(float(i)/10)
		nx = x+cos(tang)*length
		ny = y+sin(tang)*length
		col = float(length)/float(slen)*255.0
		#(ang%255,float(x)/640.0*255,255) #((ang*20)%255,255-(ang*ang)%255,0)
		fcol = ((ang*20)%255,255-(ang*ang)%255,0)
		pygame.draw.lines(screen, fcol,0, [(x,y),(nx,ny)],length/10)
		if length > 20:ffnc(tang,length,nx,ny)
		else:pygame.draw.circle(screen, fcol,(int(nx),int(ny)),2)

pygame.init()
screen  = pygame.display.set_mode((640,480),0,32)
ingame = 1
while ingame:
	pygame.time.wait(1)
	ac1-=0.01
	ac2+=1.1
	screen.fill((0,0,0))
	ffnc(0,slen,320,240)
	pygame.display.flip()